#!/usr/bin/perl

#####################################################
#                                                   #
#      SMTP AUTH - Simple Example                   #
#                                                   #
#  This example was created by Kevin Robert Keegan  #
#  and can be freely distributed. A condition of    #
#  distribution is that the first 26 lines of this  #
#  document remain unchanged.                       #
#                                                   #
#  After looking for months for a solution to log   #
#  into an authorized SMTP server I set out to      #
#  solve the problem myself and I found the         #
#  solution to be extremely simple. Below is the    #
#  example I created to distribute my idea.         #
#                                                   #
#  If you are interested in more work that I have   #
#  created please see http://www.krkeegan.com or    #
#  kevin@krkeegan.com                               #
#                                                   #
#  Please leave these top lines intact. I am        #
#  currently looking for employment and I would     #
#  like to use this as a type of resume. Thanks     #
#                                                   #
#####################################################
print "Content-type: text/html\n\n";
print <<EOF;
  <font face="Arial, Helvetica, sans-serif" size="2"><b>Perl SMTP AUTH - Simple Example</b></font></p>
  <p><font face="Arial, Helvetica, sans-serif" size="2">To download this script 
  click <a href="http://www.krkeegan.com/smtp_auth/smtp_auth.zip">here</a>.<br>
  <br>
  This example was created by Kevin Robert Keegan and can be freely distributed. 
  A condition of <br>
  distribution is that the first 26 lines of this document remain unchanged. <br>
  <br>
  After looking for months for a solution to log into an authorized SMTP server 
  I set out to solve the<br>
  </font><font face="Arial, Helvetica, sans-serif" size="2"> problem myself and 
  I found the solution to be extremely simple. Below is the example I created 
  <br>
  to distribute my idea. <br>
  <br>
  If you are interested in more work that I have created please see <a href="http://www.krkeegan.com">http://www.krkeegan.com</a> 
  or <br>
  <a href="mailto:kevin\@krkeegan.com">kevin\@krkeegan.com</a> <br>
  <br>
  Please leave these top lines intact. I am currently looking for employment and 
  I would like to use <br>
  </font><font face="Arial, Helvetica, sans-serif" size="2">this as a type of 
  resume. Thanks </font></p>
  <p><font face="Arial, Helvetica, sans-serif" size="2">Below is a copy of the communication 
  that just occured between my mail server and this script.<br>
  </font><font face="Arial, Helvetica, sans-serif" size="2">The final line '235 
  go ahead' signifies that the server is ready to receive the mail data. </font>
  <br>
EOF

#BEGIN SCRIPT
use CGI; my $cgi=CGI->new();

$user = $cgi->param('user');
$pass = $cgi->param('pass');
$server = $cgi->param('server');

#Get user,pass,server or use defaults.
if (!defined($user)){$user = "demo";}
if (!defined($pass)){$pass = "krkeegan";}
if (!defined($server)){$server = "mail.krkeegan.com";}

print <<EOF;
  <form name="form1" method="post" action="http://www.krkeegan.com/cgi-bin/smtpauth/smtp_auth.pl">
  <font face="Arial, Helvetica, sans-serif" size="2">User: 
  <input type="text" name="user" value="$user">
  <br>
  Pass: 
  <input type="password" name="pass" value="$pass">
  <br>
  Server: 
  <input type="text" name="server" value="$server">
  <br>
  <input type="submit" name="Submit" value="Try your Server">
  </font> 
  </form><BR>
EOF

#This is a simple method to communicate with the server.
use Socket; #I used this rather than Net::SMTP to make the example more clear




#Encrypt the user and pass
$user = encode_base64($user); #Yes the encryption for AUTH is really this easy
$pass = encode_base64($pass); #Base 64 is not really and encryption just a translation
			      #But it works!

chomp($user);   #Get rid of line ending
chomp($pass);   #Get rid of line ending

#open a socket and begin cummunication with the server
    
    socket(SOCK, PF_INET, SOCK_STREAM, getprotobyname('tcp')); #set up the socket
    connect(SOCK, sockaddr_in(25, inet_aton($server))); #connect to my server on port 25
    sysread(SOCK, $Response, 1024); #Read what the server says
    print join('<br>', split(/\n/,$Response)) ."<br>"; #Print Server Greeting
    print "TX  ehlo demo\n" ."<br>";  #print our response
    send(SOCK, "ehlo demo\r\n", 0);  #Hello my name is demo
    sysread(SOCK, $Response, 1024); #Read resp
    print join('<br>', split(/\n/,$Response)) ."<br>";      #print resp


    #Tell the server we wish to use Authentication
    print "TX  AUTH LOGIN\n" ."<br>";   #print our resp
    send(SOCK, "AUTH LOGIN\r\n",0); #Ask for AUTH Login
    sysread(SOCK, $Response, 1024); #Read Resp
    print $Response ."<br>";                #Print RESP

    #the Response you see now is
    #334 VXNlcm5hbWU6
    #The stuff at the end is just Username: encoded in base64
   
    #Send the encrypted username
    print "TX  " . $user . "\n" ."<br>"; #Our Resp
    send(SOCK, $user . "\r\n", 0); #Encrypted User Name
    sysread(SOCK, $Response, 1024); #Read Resp
    print $Response ."<br>"; #print Resp

    #The response you see now is
    #334 UGFzc3dvcmQ6
    #The stuff at the end is just Password: encoded in base64
  
    #send the encrypted password
    print "TX  " . $pass . "\n" ."<br>";    #our Resp
    send(SOCK, $pass . "\r\n", 0); #Encrypted Pass
    sysread(SOCK, $_, 1024); #Read Resp
    print $_ ."<br>"; #print Resp

    #You will not get the Response
    #235 go ahead

    #A failure will return
    #535 auth failure
    
    #you are now loged in and could send a message to anyone you please.
    #I left out the command to send mail so that I do not get thousands
    #of messages, but I think the commands to send mail to SMTP via Sockets
    #is pretty well covered

    close(SOCK);


    #This is a base 64 subroutine taken from planet source code.
    #It is pretty standard. stuff.
    sub encode_base64
{
    my $res = "";
    my $eol = $_[1];
    $eol = "\n" unless defined $eol;
    pos($_[0]) = 0;                          # ensure start at the beginning
    while ($_[0] =~ /(.{1,45})/gs) {
	$res .= substr(pack('u', $1), 1);
	chop($res);
    }
    $res =~ tr|` -_|AA-Za-z0-9+/|;               # `# help emacs
    # fix padding at the end
    my $padding = (3 - length($_[0]) % 3) % 3;
    $res =~ s/.{$padding}$/'=' x $padding/e if $padding;
    # break encoded string into lines of no more than 76 characters each
    if (length $eol) {
	$res =~ s/(.{1,76})/$1$eol/g;
    }
    $res;
}

#Copyright (C) Kevin Robert Keegan, Kevin@krkeegan.com, http://www.krkeegan.com
